
#include <future>
#include <iostream>

using namespace std;

#define N 1000000

int v[N];

// funzione di conteggio delle occorrenze di un valore
// in una sezione del vettore delimitata da due indici
int search(unsigned int begin, unsigned int end, int what)
{
	int count = 0;

	for (unsigned int i = begin; i < end; i++)
		if (v[i] == what)
			count++;
	return count;
}


int main(int argc, char* argv[])
{
	int what;
	unsigned int core, count, sum = 0;
	future<int> *result;
	
	// inizializzazione del vattore con valori casuali
	for (unsigned int i = 0; i < N; i++)
		v[i] = rand();
	// acquisizione e verifica del numero di core del processore
	core = thread::hardware_concurrency();
	if (core == 0)
	{
		cout << "Errore rilevazione numero core" << endl;
		return -1;
	}
	cout << "Numero core:" << core << endl;
	// allocazione del vettore degli oggetti future di tipo int
	result = new future<int>[core];
	//richiesta all'utente del valore da ricercare	
	cout << "Inserire il valore da ricercare: ";
	cin >> what;
	// creazione degli oggetti future
	// (ricerca asincrona nelle diverse sezioni del vettore)
	for (unsigned int i = 0; i < core; i++)
		result[i] = async(&search, N / core*i, N / core*(i + 1), what);
	// recupero e visualizzazione dei risultati
	cout << "Trovati:" << endl;
	for (unsigned int i = 0; i < core - 1; i++)
	{
		count = result[i].get();
		cout << count << "+" << endl;
		sum += count;
	}
	count = result[core - 1].get();
	cout << count << "=" << endl;
	sum += count;
	cout << sum << " valori" << endl;
	delete[] result;
	return 0;
}