
#include <thread>
#include <chrono>
#include <mutex>
#include <ctime>
#include <iostream>

using namespace std;


class serial_number_provider
{
 private:

	mutex access;
	unsigned long value;

 public:

	// costruttore
	serial_number_provider(void)
	{
		value = 0;
	}

	// accesso thread-safe al valore sequenziale
	unsigned long getValue(void)
	{
		unsigned long tmp;

		access.lock();
		tmp = value;
		value++;
		access.unlock();
		return tmp;
	}
};

serial_number_provider *sequencer;
bool active = true;

// thread consumatore dei valori sequenziali
void leggi(unsigned int period)
{
	unsigned long value;

	while (active)
	{
		this_thread::sleep_for(chrono::seconds(period));
		value = sequencer->getValue();
		cout << this_thread::get_id() << "\t" << value << endl;
	}
}

int main(int argc, char* argv[])
{
	thread* lettori[10];
	char tmp;
	
	// attivazione oggetto produttore dei dati
	sequencer = new serial_number_provider();
	// esecuzione dei thread lettori con periodo di accesso casuale
	for (int i = 0; i < 10; i++)
		lettori[i] = new thread(leggi, rand()%5+1);

	cout << "Premere un tasto qualsiasi seguito da \"Invio\" per terminare" << endl;
	cin >> tmp;
	active = false;
	// attesa della conclusione dei thread e chiusura dei file
	for (int i = 0; i < 10; i++)
	{
		lettori[i]->join();
		delete lettori[i];
	}
	delete sequencer;

	return 0;
}
