#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#include "lib.h"

#define DIM 10

struct CARD_TEST
{
 unsigned long card_id;
 unsigned long en_code;
};

struct CARD_TEST cards[DIM];
pthread_mutex_t mutex;
int end = 0;

void generateId(struct CARD_TEST *cards)
{
 int i;
 
 for (i = 0; i<DIM; i++)
    {
 	 cards[i].card_id = (unsigned long)(rand()%900000 + 100000);
 	 //printf("%lu\r\n", cards[i].card_id);
 	}
 return;
}

int findCard(unsigned long id)
{
 int i;
 
 for (i=0; i<DIM; i++)
    if (cards[i].card_id == id)
      return i;
 return -1;
}



void* writer(void* arg)
{
 int i;
 unsigned long code;
 
 while (!end) {
      for (i = 0; i<DIM; i++)
         {
          code = getEnableCode(cards[i].card_id);
          pthread_mutex_lock(&mutex);
          cards[i].en_code = code;
          pthread_mutex_unlock(&mutex);      
        }
    }
 pthread_exit(NULL);
}

void* reader(void* arg)
{
 unsigned long* p = (unsigned long*)arg;
 unsigned long id = *p;
 unsigned long code;
 int index = findCard(id);
 
 while (!end)
      {
       usleep(1000000);
       pthread_mutex_lock(&mutex);
       code = cards[index].en_code;
       pthread_mutex_unlock(&mutex);
       printf("ID=%lu EN=%lu\r\n", id, code);
      }
 pthread_exit(NULL);
}




int main()
{
 pthread_t R_thread[DIM], W_thread;
 int n;
 char c;
 
 generateId(cards);
 
 pthread_mutex_init(&mutex, NULL);
 
 pthread_create(&W_thread, NULL, &writer, NULL);
 for (n=0; n<DIM; n++)
    {
     pthread_create(&R_thread[n], NULL, &reader, (void*)&cards[n].card_id);
     pthread_detach(R_thread[n]);
    }
 
 printf("Inserire un carattere qualsiasi per terminare\r\n");
 scanf("%c", &c);
 end = 1;
 
 pthread_join(W_thread, NULL);
 pthread_mutex_destroy(&mutex);
 return 0;
}
